// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: emulator_controller.proto

package com.android.emulator.control;

/**
 * <pre>
 * A TouchEvent contains a list of Touch objects that are in contact with
 * the touch surface.
 *
 * Touch events are delivered in sequence as specified in the touchList.
 *
 * TouchEvents are delivered to the emulated devices using ["Protocol
 * B"](https://www.kernel.org/doc/Documentation/input/multi-touch-protocol.txt)
 * </pre>
 *
 * Protobuf type {@code android.emulation.control.TouchEvent}
 */
public final class TouchEvent extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:android.emulation.control.TouchEvent)
    TouchEventOrBuilder {
private static final long serialVersionUID = 0L;
  // Use TouchEvent.newBuilder() to construct.
  private TouchEvent(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private TouchEvent() {
    touches_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new TouchEvent();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_TouchEvent_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_TouchEvent_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.android.emulator.control.TouchEvent.class, com.android.emulator.control.TouchEvent.Builder.class);
  }

  public static final int TOUCHES_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private java.util.List<com.android.emulator.control.Touch> touches_;
  /**
   * <pre>
   * The list of Touch objects, note that these do not need to be unique
   * </pre>
   *
   * <code>repeated .android.emulation.control.Touch touches = 1;</code>
   */
  @java.lang.Override
  public java.util.List<com.android.emulator.control.Touch> getTouchesList() {
    return touches_;
  }
  /**
   * <pre>
   * The list of Touch objects, note that these do not need to be unique
   * </pre>
   *
   * <code>repeated .android.emulation.control.Touch touches = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.android.emulator.control.TouchOrBuilder> 
      getTouchesOrBuilderList() {
    return touches_;
  }
  /**
   * <pre>
   * The list of Touch objects, note that these do not need to be unique
   * </pre>
   *
   * <code>repeated .android.emulation.control.Touch touches = 1;</code>
   */
  @java.lang.Override
  public int getTouchesCount() {
    return touches_.size();
  }
  /**
   * <pre>
   * The list of Touch objects, note that these do not need to be unique
   * </pre>
   *
   * <code>repeated .android.emulation.control.Touch touches = 1;</code>
   */
  @java.lang.Override
  public com.android.emulator.control.Touch getTouches(int index) {
    return touches_.get(index);
  }
  /**
   * <pre>
   * The list of Touch objects, note that these do not need to be unique
   * </pre>
   *
   * <code>repeated .android.emulation.control.Touch touches = 1;</code>
   */
  @java.lang.Override
  public com.android.emulator.control.TouchOrBuilder getTouchesOrBuilder(
      int index) {
    return touches_.get(index);
  }

  public static final int DISPLAY_FIELD_NUMBER = 2;
  private int display_ = 0;
  /**
   * <pre>
   * The display device where the touch event occurred.
   * Omitting or using the value 0 indicates the main display.
   *
   * Touch events cannot be send to displays other than 0, due to
   * https://issuetracker.google.com/issues/150699691
   * </pre>
   *
   * <code>int32 display = 2;</code>
   * @return The display.
   */
  @java.lang.Override
  public int getDisplay() {
    return display_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < touches_.size(); i++) {
      output.writeMessage(1, touches_.get(i));
    }
    if (display_ != 0) {
      output.writeInt32(2, display_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < touches_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, touches_.get(i));
    }
    if (display_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeInt32Size(2, display_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.android.emulator.control.TouchEvent)) {
      return super.equals(obj);
    }
    com.android.emulator.control.TouchEvent other = (com.android.emulator.control.TouchEvent) obj;

    if (!getTouchesList()
        .equals(other.getTouchesList())) return false;
    if (getDisplay()
        != other.getDisplay()) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getTouchesCount() > 0) {
      hash = (37 * hash) + TOUCHES_FIELD_NUMBER;
      hash = (53 * hash) + getTouchesList().hashCode();
    }
    hash = (37 * hash) + DISPLAY_FIELD_NUMBER;
    hash = (53 * hash) + getDisplay();
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.android.emulator.control.TouchEvent parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.android.emulator.control.TouchEvent parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.TouchEvent parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.TouchEvent parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.android.emulator.control.TouchEvent prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * A TouchEvent contains a list of Touch objects that are in contact with
   * the touch surface.
   *
   * Touch events are delivered in sequence as specified in the touchList.
   *
   * TouchEvents are delivered to the emulated devices using ["Protocol
   * B"](https://www.kernel.org/doc/Documentation/input/multi-touch-protocol.txt)
   * </pre>
   *
   * Protobuf type {@code android.emulation.control.TouchEvent}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:android.emulation.control.TouchEvent)
      com.android.emulator.control.TouchEventOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_TouchEvent_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_TouchEvent_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.android.emulator.control.TouchEvent.class, com.android.emulator.control.TouchEvent.Builder.class);
    }

    // Construct using com.android.emulator.control.TouchEvent.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (touchesBuilder_ == null) {
        touches_ = java.util.Collections.emptyList();
      } else {
        touches_ = null;
        touchesBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      display_ = 0;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_TouchEvent_descriptor;
    }

    @java.lang.Override
    public com.android.emulator.control.TouchEvent getDefaultInstanceForType() {
      return com.android.emulator.control.TouchEvent.getDefaultInstance();
    }

    @java.lang.Override
    public com.android.emulator.control.TouchEvent build() {
      com.android.emulator.control.TouchEvent result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.android.emulator.control.TouchEvent buildPartial() {
      com.android.emulator.control.TouchEvent result = new com.android.emulator.control.TouchEvent(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.android.emulator.control.TouchEvent result) {
      if (touchesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          touches_ = java.util.Collections.unmodifiableList(touches_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.touches_ = touches_;
      } else {
        result.touches_ = touchesBuilder_.build();
      }
    }

    private void buildPartial0(com.android.emulator.control.TouchEvent result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.display_ = display_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.android.emulator.control.TouchEvent) {
        return mergeFrom((com.android.emulator.control.TouchEvent)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.android.emulator.control.TouchEvent other) {
      if (other == com.android.emulator.control.TouchEvent.getDefaultInstance()) return this;
      if (touchesBuilder_ == null) {
        if (!other.touches_.isEmpty()) {
          if (touches_.isEmpty()) {
            touches_ = other.touches_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureTouchesIsMutable();
            touches_.addAll(other.touches_);
          }
          onChanged();
        }
      } else {
        if (!other.touches_.isEmpty()) {
          if (touchesBuilder_.isEmpty()) {
            touchesBuilder_.dispose();
            touchesBuilder_ = null;
            touches_ = other.touches_;
            bitField0_ = (bitField0_ & ~0x00000001);
            touchesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getTouchesFieldBuilder() : null;
          } else {
            touchesBuilder_.addAllMessages(other.touches_);
          }
        }
      }
      if (other.getDisplay() != 0) {
        setDisplay(other.getDisplay());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              com.android.emulator.control.Touch m =
                  input.readMessage(
                      com.android.emulator.control.Touch.parser(),
                      extensionRegistry);
              if (touchesBuilder_ == null) {
                ensureTouchesIsMutable();
                touches_.add(m);
              } else {
                touchesBuilder_.addMessage(m);
              }
              break;
            } // case 10
            case 16: {
              display_ = input.readInt32();
              bitField0_ |= 0x00000002;
              break;
            } // case 16
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.util.List<com.android.emulator.control.Touch> touches_ =
      java.util.Collections.emptyList();
    private void ensureTouchesIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        touches_ = new java.util.ArrayList<com.android.emulator.control.Touch>(touches_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.android.emulator.control.Touch, com.android.emulator.control.Touch.Builder, com.android.emulator.control.TouchOrBuilder> touchesBuilder_;

    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public java.util.List<com.android.emulator.control.Touch> getTouchesList() {
      if (touchesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(touches_);
      } else {
        return touchesBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public int getTouchesCount() {
      if (touchesBuilder_ == null) {
        return touches_.size();
      } else {
        return touchesBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public com.android.emulator.control.Touch getTouches(int index) {
      if (touchesBuilder_ == null) {
        return touches_.get(index);
      } else {
        return touchesBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder setTouches(
        int index, com.android.emulator.control.Touch value) {
      if (touchesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureTouchesIsMutable();
        touches_.set(index, value);
        onChanged();
      } else {
        touchesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder setTouches(
        int index, com.android.emulator.control.Touch.Builder builderForValue) {
      if (touchesBuilder_ == null) {
        ensureTouchesIsMutable();
        touches_.set(index, builderForValue.build());
        onChanged();
      } else {
        touchesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder addTouches(com.android.emulator.control.Touch value) {
      if (touchesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureTouchesIsMutable();
        touches_.add(value);
        onChanged();
      } else {
        touchesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder addTouches(
        int index, com.android.emulator.control.Touch value) {
      if (touchesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureTouchesIsMutable();
        touches_.add(index, value);
        onChanged();
      } else {
        touchesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder addTouches(
        com.android.emulator.control.Touch.Builder builderForValue) {
      if (touchesBuilder_ == null) {
        ensureTouchesIsMutable();
        touches_.add(builderForValue.build());
        onChanged();
      } else {
        touchesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder addTouches(
        int index, com.android.emulator.control.Touch.Builder builderForValue) {
      if (touchesBuilder_ == null) {
        ensureTouchesIsMutable();
        touches_.add(index, builderForValue.build());
        onChanged();
      } else {
        touchesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder addAllTouches(
        java.lang.Iterable<? extends com.android.emulator.control.Touch> values) {
      if (touchesBuilder_ == null) {
        ensureTouchesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, touches_);
        onChanged();
      } else {
        touchesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder clearTouches() {
      if (touchesBuilder_ == null) {
        touches_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        touchesBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public Builder removeTouches(int index) {
      if (touchesBuilder_ == null) {
        ensureTouchesIsMutable();
        touches_.remove(index);
        onChanged();
      } else {
        touchesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public com.android.emulator.control.Touch.Builder getTouchesBuilder(
        int index) {
      return getTouchesFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public com.android.emulator.control.TouchOrBuilder getTouchesOrBuilder(
        int index) {
      if (touchesBuilder_ == null) {
        return touches_.get(index);  } else {
        return touchesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public java.util.List<? extends com.android.emulator.control.TouchOrBuilder> 
         getTouchesOrBuilderList() {
      if (touchesBuilder_ != null) {
        return touchesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(touches_);
      }
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public com.android.emulator.control.Touch.Builder addTouchesBuilder() {
      return getTouchesFieldBuilder().addBuilder(
          com.android.emulator.control.Touch.getDefaultInstance());
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public com.android.emulator.control.Touch.Builder addTouchesBuilder(
        int index) {
      return getTouchesFieldBuilder().addBuilder(
          index, com.android.emulator.control.Touch.getDefaultInstance());
    }
    /**
     * <pre>
     * The list of Touch objects, note that these do not need to be unique
     * </pre>
     *
     * <code>repeated .android.emulation.control.Touch touches = 1;</code>
     */
    public java.util.List<com.android.emulator.control.Touch.Builder> 
         getTouchesBuilderList() {
      return getTouchesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.android.emulator.control.Touch, com.android.emulator.control.Touch.Builder, com.android.emulator.control.TouchOrBuilder> 
        getTouchesFieldBuilder() {
      if (touchesBuilder_ == null) {
        touchesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.android.emulator.control.Touch, com.android.emulator.control.Touch.Builder, com.android.emulator.control.TouchOrBuilder>(
                touches_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        touches_ = null;
      }
      return touchesBuilder_;
    }

    private int display_ ;
    /**
     * <pre>
     * The display device where the touch event occurred.
     * Omitting or using the value 0 indicates the main display.
     *
     * Touch events cannot be send to displays other than 0, due to
     * https://issuetracker.google.com/issues/150699691
     * </pre>
     *
     * <code>int32 display = 2;</code>
     * @return The display.
     */
    @java.lang.Override
    public int getDisplay() {
      return display_;
    }
    /**
     * <pre>
     * The display device where the touch event occurred.
     * Omitting or using the value 0 indicates the main display.
     *
     * Touch events cannot be send to displays other than 0, due to
     * https://issuetracker.google.com/issues/150699691
     * </pre>
     *
     * <code>int32 display = 2;</code>
     * @param value The display to set.
     * @return This builder for chaining.
     */
    public Builder setDisplay(int value) {

      display_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The display device where the touch event occurred.
     * Omitting or using the value 0 indicates the main display.
     *
     * Touch events cannot be send to displays other than 0, due to
     * https://issuetracker.google.com/issues/150699691
     * </pre>
     *
     * <code>int32 display = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearDisplay() {
      bitField0_ = (bitField0_ & ~0x00000002);
      display_ = 0;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:android.emulation.control.TouchEvent)
  }

  // @@protoc_insertion_point(class_scope:android.emulation.control.TouchEvent)
  private static final com.android.emulator.control.TouchEvent DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.android.emulator.control.TouchEvent();
  }

  public static com.android.emulator.control.TouchEvent getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<TouchEvent>
      PARSER = new com.google.protobuf.AbstractParser<TouchEvent>() {
    @java.lang.Override
    public TouchEvent parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<TouchEvent> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<TouchEvent> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.android.emulator.control.TouchEvent getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

